 /*
  * bitfont.h - Bitmap Font Blitting Object
  * Copyright (c)2004 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#ifndef __BITFONT_H__
#define __BITFONT_H__

#include "gpgraphic.h"
#include "gfx.h"

class BitFont  
{
	public:
		BitFont(unsigned char *data, int width, int height);
		virtual ~BitFont();
		void putchar(GPDRAWSURFACE *surface, int index, int x_pos, int y_pos, int color);
		void putchar_rev(GPDRAWSURFACE *surface, int index, int x_pos, int y_pos, int color);
		int get_width();
		int get_height();
		int get_byte_width();
	private:
		int calc_byte_width(int width);
		unsigned char *font_data;
		int font_width;
		int font_height;
		int font_byte_width;
};

#endif /*__BITFONT_H__*/
