 /*
  * jiten.h - Dictionary Lookup Object
  * Copyright (c)2004 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#ifndef __JITEN_H__
#define __JITEN_H__

#include "gpstdio.h"

class Jiten  
{
public:
	int next();
	int get_record(char * definition);
	int num_matches();
	int search(char *term);
	int load(char *dict_filename, char *idx_filename);
	Jiten();
	virtual ~Jiten();

private:
	void reset();
	char * search_term; // The likely culprit?
	int last_match();
	int first_match();
	int kstrncmp(const char *s1, const char *s2, int n);
	unsigned char * dictionary;			
	unsigned long * index;				
	unsigned long dictionary_length;	
	unsigned long index_length;			
	int index_current_element;
	int index_first_element;
	int index_last_element;
};

#endif /*__JITEN_H__*/
